"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = __importDefault(require(".."));
const humble_localstorage_1 = __importDefault(require("humble-localstorage"));
function* range(n, i = 0) {
    for (; i < n; i++)
        yield i;
}
class LocalStorageDOWN {
    _key(k) {
        return this._prefix + k;
    }
    open({ location }) {
        return __awaiter(this, void 0, void 0, function* () {
            this._prefix = '!' + location + '!';
        });
    }
    get(k) {
        return __awaiter(this, void 0, void 0, function* () {
            const v = humble_localstorage_1.default.getItem(this._key(k));
            if (v === undefined)
                throw new Error('NotFound');
            return v;
        });
    }
    put(k, v) {
        return __awaiter(this, void 0, void 0, function* () {
            humble_localstorage_1.default.setItem(this._key(k), v);
        });
    }
    del(k) {
        return __awaiter(this, void 0, void 0, function* () {
            humble_localstorage_1.default.removeItem(this._key(k));
        });
    }
    iterator(opts) {
        return __asyncGenerator(this, arguments, function* iterator_1() {
            const keys = [...range(humble_localstorage_1.default.length)].map(// get keys
            (i) => humble_localstorage_1.default.key(i)).filter(// filter by prefix
            (k) => k.slice(0, this._prefix.length) === this._prefix).map(// remove prefix
            (k) => k.slice(this._prefix.length)).sort(); // sort keys
            if (opts.reverse)
                keys.reverse();
            for (const k of keys) {
                yield yield __await({
                    key: k,
                    value: humble_localstorage_1.default.getItem(k)
                });
            }
        });
    }
}
exports.default = __1.default(LocalStorageDOWN);
//# sourceMappingURL=localstoragedown.js.map