import { AbstractLevelDOWN, AbstractGetOptions, AbstractOptions, ErrorCallback, ErrorValueCallback, AbstractIteratorOptions, AbstractIterator } from 'abstract-leveldown';
import { EasierLevelDOWN, MaybeLocation, EasierLevelDOWNBatchOpts } from './abstract';
import { StringOrBuffer } from './types';
export declare class EasierAbstractLevelDOWN<K, V, O extends MaybeLocation> extends AbstractLevelDOWN<StringOrBuffer, StringOrBuffer> {
    _db: EasierLevelDOWN<K, V, O>;
    _location: string | undefined;
    constructor(db: EasierLevelDOWN<K, V, O>, location?: string);
    _open(options: O, callback: ErrorCallback): void;
    _close(callback: ErrorCallback): void;
    _get(key: StringOrBuffer, options: AbstractGetOptions, callback: ErrorValueCallback<V>): void;
    _put(key: StringOrBuffer, val: StringOrBuffer, options: AbstractOptions, callback: ErrorCallback): void;
    _del(key: StringOrBuffer, options: AbstractOptions, callback: ErrorCallback): void;
    _batch(array: EasierLevelDOWNBatchOpts<StringOrBuffer, StringOrBuffer>, options: AbstractOptions, callback: ErrorCallback): void;
    _iterator(options: AbstractIteratorOptions<K>): AbstractIterator<StringOrBuffer, StringOrBuffer>;
    _encodeKey(key: K): StringOrBuffer;
    _decodeKey(key: StringOrBuffer): K;
    _encodeValue(value: V): StringOrBuffer;
    _decodeValue(value: StringOrBuffer): V;
}
