/// <reference types="node" />
import { EventEmitter } from "events";
import { EasierLevelDOWNEventEmitter, EasierLevelDOWNBatchOpts } from "./abstract";
export declare class EasierLevelUpEmitter<K, V> extends EventEmitter implements EasierLevelDOWNEventEmitter<K, V> {
    emitPut(key: K, value: V): boolean;
    emitDel(key: K): boolean;
    emitBatch(array: EasierLevelDOWNBatchOpts<K, V>): boolean;
    onPut(cb: (key: K, value: V) => void): this;
    onDel(cb: (key: K) => void): this;
    onBatch(cb: (array: EasierLevelDOWNBatchOpts<K, V>) => void): this;
}
