"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ltgt_1 = __importDefault(require("ltgt"));
function normalize_options(options) {
    if (options === undefined)
        options = {};
    if (options.limit === -1)
        options.limit = Infinity;
    if (options.reverse === true)
        options.reverse = true;
    else
        options.reverse = false;
    let opts = {
        keys: options.keys,
        values: options.values,
        createIfMissing: options.createIfMissing,
        errorIfExists: options.errorIfExists,
        keyEncoding: options.keyEncoding,
        valueEncoding: options.valueEncoding,
        compression: options.compression,
        db: options.db,
        limit: options.limit,
        keyAsBuffer: options.keyAsBuffer,
        valueAsBuffer: options.valueAsBuffer,
        reverse: options.reverse,
        fillCache: options.fillCache,
    };
    if (!options.reverse) {
        let lowerBound = ltgt_1.default.lowerBound(options);
        let upperBound = ltgt_1.default.upperBound(options);
        if (Buffer.isBuffer(lowerBound)) {
            lowerBound = lowerBound.toString();
        }
        if (Buffer.isBuffer(upperBound)) {
            upperBound = upperBound.toString();
        }
        if (typeof lowerBound === 'undefined' || lowerBound == null || lowerBound == '') {
        }
        else if (ltgt_1.default.lowerBoundInclusive(options)) {
            opts.gte = lowerBound;
        }
        else {
            opts.gt = lowerBound;
        }
        if (typeof upperBound === 'undefined' || upperBound == null || upperBound == '') {
        }
        else if (ltgt_1.default.upperBoundInclusive(options)) {
            opts.lte = upperBound;
        }
        else {
            opts.lt = upperBound;
        }
    }
    else {
        let lowerBound = ltgt_1.default.upperBound(options);
        let upperBound = ltgt_1.default.lowerBound(options);
        if (Buffer.isBuffer(lowerBound)) {
            lowerBound = lowerBound.toString();
        }
        if (Buffer.isBuffer(upperBound)) {
            upperBound = upperBound.toString();
        }
        if (typeof lowerBound === 'undefined' || lowerBound == null || lowerBound == '') {
        }
        else if (ltgt_1.default.upperBoundInclusive(options)) {
            opts.lte = lowerBound;
        }
        else {
            opts.lt = lowerBound;
        }
        if (typeof upperBound === 'undefined' || upperBound == null || upperBound == '') {
        }
        else if (ltgt_1.default.lowerBoundInclusive(options)) {
            opts.gte = upperBound;
        }
        else {
            opts.gt = upperBound;
        }
    }
    return opts;
}
exports.normalize_options = normalize_options;
function test_from_options(options) {
    return (k) => {
        return (((options.lte !== undefined) ? ltgt_1.default.compare(String(k), String(options.lte)) <= 0 : true)
            && ((options.lt !== undefined) ? ltgt_1.default.compare(String(k), String(options.lt)) < 0 : true)
            && ((options.gte !== undefined) ? ltgt_1.default.compare(String(k), String(options.gte)) >= 0 : true)
            && ((options.gt !== undefined) ? ltgt_1.default.compare(String(k), String(options.gt)) > 0 : true));
    };
}
exports.test_from_options = test_from_options;
//# sourceMappingURL=leveldown-opts.js.map