import { AbstractLevelDOWN } from "abstract-leveldown";
import { EasierLevelDOWN, EasierLevelDOWNBatchOpts, EasierLevelDOWNEmitter, EasierLevelDOWNIteratorOpts, MaybeLocation } from "./abstract";
import { KeyVal, StringOrBuffer } from "./types";
/**
 * LevelDOWNEasier helps us treat an existing AbstractLevelDOWN compliant store as an EasierLevelDOWN one!
 *  It plays smart if the store was in-fact actually originally derived from an EasierLevelDOWN store.
 */
export declare class LevelDOWNEasier<K extends StringOrBuffer, V = any, O extends MaybeLocation = any> implements EasierLevelDOWN<K, V, O> {
    _leveldown: AbstractLevelDOWN<K, V>;
    changes?(): EasierLevelDOWNEmitter<K, V>;
    encodeKey?(key: K): StringOrBuffer;
    encodeValue?(value: V): StringOrBuffer;
    decodeKey?(key: StringOrBuffer): K;
    decodeValue?(value: StringOrBuffer): V;
    constructor(leveldown: AbstractLevelDOWN<K, V>);
    get(k: K): Promise<V>;
    put(k: K, v: V): Promise<void>;
    post(val: V): Promise<K>;
    del(k: K): Promise<void>;
    open(opts: O): Promise<void>;
    close(): Promise<void>;
    iterator(opts: EasierLevelDOWNIteratorOpts<K, V>): AsyncIterableIterator<KeyVal<K, V>>;
    batch(array: EasierLevelDOWNBatchOpts<K, V>): Promise<void>;
}
